# all files / ol/structs/ lrucache.js

74.07% Statements 80/108
83.33% Branches 10/12
84.62% Functions 11/13
74.07% Lines 80/108

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226
    227
    228
    229
    230
    231
    232
    233
    234
    235
    236
    237
    238
    239
    240
    241
    242
    243
    244
    245
    246
    247
    248
    249
    250
    251
    252
    253
    254
    255
    256
    257
    258
    259
    260
    261
    2621×

    1×
    1×

    1×

    105×

    105×

    105×

    105×

    1×

    1×
    90×
    90×
    90×
    90×

    1×
    227×

    1×

    1×
    29×
    29×
    29×
    3×
    26×
    25×
    25×

    1×
    1×

    26×
    26×
    26×
    26×
    26×

    1×
    15×

    1×
    7×
    7×
    7×
    7×
    21×

    7×
    7×

    1×
    7×
    7×
    7×
    7×
    21×

    7×
    7×

    1×
    2×
    1×

    1×
    2×
    1×

    1×
    4×
    4×
    4×
    4×

    4×
    4×
    3×

    4×
    4×
    1×

    4×
    4×

    1×
    112×

    105×

    104×

    104×
    46×

    58×

    104×
    104×
    104×

    1×
     goog.provide('ol.structs.LRUCache');

    goog.require('goog.asserts');
    goog.require('goog.object');

    /**
     * Implements a Least-Recently-Used cache where the keys do not conflict with
     * Object's properties (e.g. 'hasOwnProperty' is not allowed as a key). Expiring
     * items from the cache is the responsibility of the user.
     * @constructor
     * @struct
     * @template T
     */
    ol.structs.LRUCache = function() {

      /**
       * @private
       * @type {number}
       */
      this.count_ = 0;

      /**
       * @private
       * @type {Object.<string, ol.structs.LRUCacheEntry>}
       */
      this.entries_ = {};

      /**
       * @private
       * @type {?ol.structs.LRUCacheEntry}
       */
      this.oldest_ = null;

      /**
       * @private
       * @type {?ol.structs.LRUCacheEntry}
       */
      this.newest_ = null;

    };

    /**
     * FIXME empty description for jsdoc
     */
    ol.structs.LRUCache.prototype.assertValid = function() {
      if (this.count_ === 0) {
        goog.asserts.assert(goog.object.isEmpty(this.entries_),
            'entries must be an empty object (count = 0)');
        goog.asserts.assert(!this.oldest_,
            'oldest must be null (count = 0)');
        goog.asserts.assert(!this.newest_,
            'newest must be null (count = 0)');
      } else {
        goog.asserts.assert(goog.object.getCount(this.entries_) == this.count_,
            'number of entries matches count');
        goog.asserts.assert(this.oldest_,
            'we have an oldest entry');
        goog.asserts.assert(!this.oldest_.older,
            'no entry is older than oldest');
        goog.asserts.assert(this.newest_,
            'we have a newest entry');
        goog.asserts.assert(!this.newest_.newer,
            'no entry is newer than newest');
        var i, entry;
        var older = null;
        i = 0;
        for (entry = this.oldest_; entry; entry = entry.newer) {
          goog.asserts.assert(entry.older === older,
              'entry.older links to correct older');
          older = entry;
          ++i;
        }
        goog.asserts.assert(i == this.count_, 'iterated correct amount of times');
        var newer = null;
        i = 0;
        for (entry = this.newest_; entry; entry = entry.older) {
          goog.asserts.assert(entry.newer === newer,
              'entry.newer links to correct newer');
          newer = entry;
          ++i;
        }
        goog.asserts.assert(i == this.count_, 'iterated correct amount of times');
      }
    };

    /**
     * FIXME empty description for jsdoc
     */
    ol.structs.LRUCache.prototype.clear = function() {
      this.count_ = 0;
      this.entries_ = {};
      this.oldest_ = null;
      this.newest_ = null;
    };

    /**
     * @param {string} key Key.
     * @return {boolean} Contains key.
     */
    ol.structs.LRUCache.prototype.containsKey = function(key) {
      return this.entries_.hasOwnProperty(key);
    };

    /**
     * @param {function(this: S, T, string, ol.structs.LRUCache): ?} f The function
     *     to call for every entry from the oldest to the newer. This function takes
     *     3 arguments (the entry value, the entry key and the LRUCache object).
     *     The return value is ignored.
     * @param {S=} opt_this The object to use as `this` in `f`.
     * @template S
     */
    ol.structs.LRUCache.prototype.forEach = function(f, opt_this) {
      var entry = this.oldest_;
      while (entry) {
        f.call(opt_this, entry.value_, entry.key_, this);
        entry = entry.newer;
      }
    };

    /**
     * @param {string} key Key.
     * @return {T} Value.
     */
    ol.structs.LRUCache.prototype.get = function(key) {
      var entry = this.entries_[key];
      goog.asserts.assert(entry !== undefined, 'an entry exists for key %s', key);
      if (entry === this.newest_) {
        return entry.value_;
      } else if (entry === this.oldest_) {
        this.oldest_ = this.oldest_.newer;
        this.oldest_.older = null;
      } else {
        entry.newer.older = entry.older;
        entry.older.newer = entry.newer;
      }
      entry.newer = null;
      entry.older = this.newest_;
      this.newest_.newer = entry;
      this.newest_ = entry;
      return entry.value_;
    };

    /**
     * @return {number} Count.
     */
    ol.structs.LRUCache.prototype.getCount = function() {
      return this.count_;
    };

    /**
     * @return {Array.<string>} Keys.
     */
    ol.structs.LRUCache.prototype.getKeys = function() {
      var keys = new Array(this.count_);
      var i = 0;
      var entry;
      for (entry = this.newest_; entry; entry = entry.older) {
        keys[i++] = entry.key_;
      }
      goog.asserts.assert(i == this.count_, 'iterated correct number of times');
      return keys;
    };

    /**
     * @return {Array.<T>} Values.
     */
    ol.structs.LRUCache.prototype.getValues = function() {
      var values = new Array(this.count_);
      var i = 0;
      var entry;
      for (entry = this.newest_; entry; entry = entry.older) {
        values[i++] = entry.value_;
      }
      goog.asserts.assert(i == this.count_, 'iterated correct number of times');
      return values;
    };

    /**
     * @return {T} Last value.
     */
    ol.structs.LRUCache.prototype.peekLast = function() {
      goog.asserts.assert(this.oldest_, 'oldest must not be null');
      return this.oldest_.value_;
    };

    /**
     * @return {string} Last key.
     */
    ol.structs.LRUCache.prototype.peekLastKey = function() {
      goog.asserts.assert(this.oldest_, 'oldest must not be null');
      return this.oldest_.key_;
    };

    /**
     * @return {T} value Value.
     */
    ol.structs.LRUCache.prototype.pop = function() {
      goog.asserts.assert(this.oldest_, 'oldest must not be null');
      goog.asserts.assert(this.newest_, 'newest must not be null');
      var entry = this.oldest_;
      goog.asserts.assert(entry.key_ in this.entries_,
          'oldest is indexed in entries');
      delete this.entries_[entry.key_];
      if (entry.newer) {
        entry.newer.older = null;
      }
      this.oldest_ = entry.newer;
      if (!this.oldest_) {
        this.newest_ = null;
      }
      --this.count_;
      return entry.value_;
    };

    /**
     * @param {string} key Key.
     * @param {T} value Value.
     */
    ol.structs.LRUCache.prototype.set = function(key, value) {
      goog.asserts.assert(!(key in {}),
          'key is not a standard property of objects (e.g. "__proto__")');
      goog.asserts.assert(!(key in this.entries_),
          'key is not used already');
      var entry = {
        key_: key,
        newer: null,
        older: this.newest_,
        value_: value
      };
      if (!this.newest_) {
        this.oldest_ = entry;
      } else {
        this.newest_.newer = entry;
      }
      this.newest_ = entry;
      this.entries_[key] = entry;
      ++this.count_;
    };

    /**
     * @typedef {{key_: string,
     *            newer: ol.structs.LRUCacheEntry,
     *            older: ol.structs.LRUCacheEntry,
     *            value_: *}}
     */
    ol.structs.LRUCacheEntry;